Attribute VB_Name = "Module1"
Option Explicit

' Menustat sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999-2000 by Matt Hart
'
' This software is FREEWARE. You may use it as you see fit for
' your own projects but you may not re-sell the original or the
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/free/menustat.htm"
'
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' Updated 12-21-2000 to include top level menu text

Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal b As Boolean, lpMenuItemInfo As MENUITEMINFO) As Long
Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
    
Public Const GWL_WNDPROC = (-4)
Public Const WM_MENUSELECT = &H11F
Public Const MF_POPUP = &H10&
Public Const MF_SYSMENU = &H2000&
Public Const MIIM_SUBMENU = &H4
Public Const MIIM_TYPE = &H10
Public Const MIIM_DATA = &H20
Public Const MF_BYPOSITION = &H400&

Public origWndProc As Long

Public Sub SetHook(hwnd, bSet As Boolean)
    If bSet Then
        origWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf AppWndProc)
    ElseIf origWndProc Then
        Dim lRet As Long
        lRet = SetWindowLong(hwnd, GWL_WNDPROC, origWndProc)
        origWndProc = 0
    End If
End Sub

Public Function AppWndProc(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim iHi As Integer, iLo As Integer
    Select Case Msg
        Case WM_MENUSELECT
            Form1.lblStatus.Caption = ""
            CopyMemory iLo, wParam, 2
            CopyMemory iHi, ByVal VarPtr(wParam) + 2, 2
            If (iHi And MF_SYSMENU) = 0 Then
                Dim m As MENUITEMINFO, aCap As String, mSub As Long
                m.dwTypeData = Space$(64)
                m.cbSize = Len(m)
                m.cch = 64
                If iHi And MF_POPUP Then
                    mSub = GetSubMenu(lParam, CLng(iLo))
                    If mSub Then
                        m.fMask = MIIM_DATA Or MIIM_TYPE
                        If GetMenuString(lParam, CLng(iLo), m.dwTypeData, 64, MF_BYPOSITION) Then
                            aCap = m.dwTypeData & Chr$(0)
                            aCap = Left$(aCap, InStr(aCap, Chr$(0)) - 1)
                            Form1.lblStatus.Caption = aCap
                        Else
                            Form1.lblStatus.Caption = "**unknown**"
                        End If
                    Else
                        Form1.lblStatus.Caption = "**unknown**"
                    End If
                Else
                    m.fMask = MIIM_DATA Or MIIM_TYPE
                    If GetMenuItemInfo(lParam, CLng(iLo), False, m) Then
                        aCap = m.dwTypeData & Chr$(0)
                        aCap = Left$(aCap, InStr(aCap, Chr$(0)) - 1)
                        Select Case aCap
                            Case "&Open": Form1.lblStatus.Caption = "Open a file"
                            Case "&Save": Form1.lblStatus.Caption = "Save a file"
                            Case "E&xit": Form1.lblStatus.Caption = "Exit the program"
                            Case "C&ut": Form1.lblStatus.Caption = "Cut text to the clipboard"
                            Case "&Copy": Form1.lblStatus.Caption = "Copy text to the clipboard"
                            Case "&Paste": Form1.lblStatus.Caption = "Paste text from the clipboard"
                            Case Else: Form1.lblStatus.Caption = aCap
                        End Select
                    Else
                        Form1.lblStatus.Caption = "**unknown**"
                    End If
                End If
            End If
    End Select
    AppWndProc = CallWindowProc(origWndProc, hwnd, Msg, wParam, lParam)
End Function
